package com.bocloud.cos.booter.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

/**
 * @author dmw
 */
@EnableSwagger2
@Configuration
public class SwaggerConfiguration {

    @Bean(value = "default2.0")
    public Docket default2() {
        return new Docket(DocumentationType.SWAGGER_2)
                .apiInfo(new ApiInfoBuilder()
                        .title("系统运营管理API接口文档")
                        .description("系统运营管理API接口文档")
                        .termsOfServiceUrl("http://www.bocloud.com/")
                        .contact(new Contact("丁明威", "b", "d"))
                        .version("1.0")
                        .build())
                //分组名称
                .groupName("5.6版本")
                .select()
                //这里指定Controller扫描包路径
                .apis(RequestHandlerSelectors.basePackage("com.bocloud.cos.booter.controller"))
                .paths(PathSelectors.any())
                .build();
    }
}
