package com.bocloud.cos.booter.controller;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.cos.intf.PortalElementConfigService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 组件配置元素controller层
 *
 * @author lyy
 * @version 2.0
 * @time 2017年12月27日
 */
@RestController
@RequestMapping("/v1/portal/elements")
@Api(value = "组件配置管理", tags = "组件配置管理")
public class PortalElementConfigController {
    @Autowired
    private PortalElementConfigService portalElementConfigService;

    /**
     * 组件配置元素列表展示
     *
     * @param poolId
     * @return
     */
    @ApiOperation(tags = {"CMC", "CSC"}, value = "组件配置元素列表展示", response = BocloudResult.class, produces = MediaType.APPLICATION_JSON_VALUE)
    @GetMapping
    public BocloudResult list(@RequestParam(value = "poolId") Long poolId) {
        if (null != poolId) {
            return portalElementConfigService.list(poolId);
        } else {
            return new BocloudResult(false, "参数格式不正确");
        }
    }
}
