package com.bocloud.cos.booter.controller;


import com.bocloud.common.model.BocloudResult;
import com.bocloud.cos.intf.PortalElementPoolService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 组件池controller层
 *
 * @author lyy
 * @version 2.0
 * @time 2017年12月27日
 */
@RestController
@RequestMapping("/v1/portal/elementpools")
@Api(value = "组件池管理", tags = "组件池管理")
public class PortalElementPoolController {
    @Autowired
    private PortalElementPoolService portalElementPoolService;

    /**
     * 组件池列表展示
     *
     * @param serverName
     * @return
     */
    @ApiOperation(tags = {"CMC", "CSC"}, value = "组件池列表展示", response = BocloudResult.class, produces = MediaType.APPLICATION_JSON_VALUE)
    @GetMapping
    public BocloudResult list(@RequestParam(value = "serverName", required = false) String serverName) {
        if (null != serverName) {
            return portalElementPoolService.list(serverName);
        } else {
            return new BocloudResult(false, "参数格式不正确");
        }
    }
}
