package com.bocloud.cos.booter.listener;

import com.bocloud.cos.entity.VendorSyncRecord;
import com.bocloud.cos.intf.VendorSyncRecordService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 云平台同步记录监听器
 *
 * @author zhangdi
 * @since Oct 29,2019
 */

@Component
public class VendorSyncRecordListener {
    private static final Logger logger = LoggerFactory.getLogger(VendorSyncRecordListener.class);


    @Autowired
    private VendorSyncRecordService vendorSyncRecordService;

    /**
     * 将云平台同步记保存到数据库
     *
     * @param record
     */
    @RabbitListener(queues = "vendor.record.queue", admin = "rabbitAdmin", autoStartup = "true")
    public void saveRecord(VendorSyncRecord record) {
        if (null == record) {
            logger.warn("Vendor sync record is empty!");
            return;
        }
        vendorSyncRecordService.save(record);
    }

}
