package com.bocloud.cos.entity;

import com.bocloud.common.utils.DateDeserializer;
import com.bocloud.common.utils.DateSerializer;
import com.bocloud.entity.annotations.*;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 优惠券
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年3月10日
 */
@NoArgsConstructor
@AllArgsConstructor
@Table("coupon")
@Deprecated
public class Coupon extends Generic {

    /**
     * id
     */
    @Setter
    @Getter
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 优惠券名称
     */
    @Setter
    @Getter
    @Column("name")
    private String name;
    /**
     * 优惠活动id
     */
    @Setter
    @Getter
    @Column("promotion_id")
    private Long promotionId;
    /**
     * 优惠券编号
     */
    @Setter
    @Getter
    @Column("sn")
    private String sn;
    /**
     * 优惠券状态 unused|used|expired
     */
    @Setter
    @Getter
    @Column("status")
    private String status;
    /**
     * 活动开始时间
     */
    @Setter
    @Getter
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column("gmt_start")
    private Date gmtStart;
    /**
     * 活动结束时间
     */
    @Setter
    @Getter
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column("gmt_finish")
    private Date gmtFinish;
    /**
     * 生效时间
     */
    @Setter
    @Getter
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column("effective_time")
    private Date effectiveTime;
    /**
     * 失效时间
     */
    @Setter
    @Getter
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column("expired_time")
    private Date expiredTime;
    /**
     * 使用时间
     */
    @Setter
    @Getter
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @IgnoreUpdate
    @Column("gmt_used")
    private Date gmtUsed;
    /**
     * 创建时间｜分配｜领取时间
     */
    @Setter
    @Getter
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column("gmt_create")
    private Date gmtCreate;
    /**
     * 租户id
     */
    @Setter
    @Getter
    @Column("tenant_id")
    private Long tenantId;
    /**
     * 优惠活动名称
     */
    @Setter
    @Getter
    @IgnoreAll
    private String promotionName;
    /**
     * 租户名称
     */
    @Setter
    @Getter
    @IgnoreAll
    private String tenantName;
    /**
     * 优惠券类型
     */
    @Setter
    @Getter
    @IgnoreAll
    private String catalog;
    /**
     * 优惠力度
     */
    @Setter
    @Getter
    @IgnoreAll
    private String rule;
    /**
     * 适用范围
     */
    @Setter
    @Getter
    @IgnoreAll
    private String scope;

    public enum Status {
        unused, // 未使用
        used, // 已使用
        expired// 已过期
    }
}
