package com.bocloud.cos.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @author tyl
 * @since 2021/5/31 20:13
 */

@Data
@EqualsAndHashCode(callSuper = true)
@Table("document")
@AllArgsConstructor
@NoArgsConstructor
public class Document extends GenericEntity {
    /**
     * 主键
     */
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 文档内容
     */
    @Column("content")
    private String content;
    /**
     * 排序
     */
    @Column("priority")
    private Long priority;
    /**
     * 父文档id
     */
    @Column("parent_id")
    private Long parentId;
    /**
     * 文档分类
     */
    @Column("category")
    private String category;
    /**
     * 文档分类
     */
    @Column("display")
    private Boolean display;

    /**
     * 用户名
     */
    @IgnoreAll
    private String username;


    /**
     * 父文档名称
     */
    @IgnoreAll
    private String parentName;
    /**
     * 子文档集合
     */
    @IgnoreAll
    private List<Document> children;

    /**
     * 枚举类 控制上架下架
     */
    public enum Status {
        /**
         * 未发布
         */
        UNPUBLISHED,
        /**
         * 已发布
         */
        PUBLISHED;
    }
}
