package com.bocloud.cos.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 图标实体类
 *
 * @author lyy
 * @version 2.0
 * @time 2017年12月13日
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("icon")
public class Icon extends Generic {
    // id
    @PK(value = PKStrategy.AUTO)
    private Long id;
    // 图标名称
    @Column("name")
    private String name;
    // 图标
    @Column("icon")
    private String icon;
    // 是否为内置
    @Column("is_reserved")
    private Boolean reserved;
    // 分类
    @Column("category")
    private String category;


    public Icon(String name, String icon, Boolean reserved, String category) {
        super();
        this.name = name;
        this.icon = icon;
        this.reserved = reserved;
        this.category = category;
    }
}
