package com.bocloud.cos.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

/**
 * 订单号
 *
 * @author wangyu
 * @version 1.0
 * @since 2019年5月17日
 */
@NoArgsConstructor
@AllArgsConstructor
@Table("order_sn")
public class OrderSn extends Generic {

    @Setter
    @Getter
    @PK(PKStrategy.AUTO)
    private Long id;// ID
    @Setter
    @Getter
    @Column("catalog_id")
    private Long catalogId;// 服务目录ID
    @Setter
    @Getter
    @Column("service_id")
    private Long serviceId;// 服务ID
    @Setter
    @Getter
    @Column("category_id")
    private Long categoryId;// 商品类型ID
    @Setter
    @Getter
    @Column("sku_id")
    private Long skuId;// 商品skuID
    @Setter
    @Getter
    @Column("catalog_sn")
    private String catalogSn;// 服务目录编号
    @Setter
    @Getter
    @Column("service_sn")
    private String serviceSn;// 服务编号
    @Setter
    @Getter
    @Column("category_sn")
    private String categorySn;// 商品类型编号
    @Setter
    @Getter
    @Column("sku_sn")
    private String skuSn;// 商品sku编号
    @Setter
    @Getter
    @Column("current_num")
    private Long currentNum;// 当前订单编号

    /**
     * @param catalogId
     * @param serviceId
     * @param categoryId
     * @param skuId
     * @param catalogSn
     * @param serviceSn
     * @param categorySn
     * @param skuSn
     * @param currentNum
     */
    public OrderSn(Long catalogId, Long serviceId, Long categoryId, Long skuId, String catalogSn, String serviceSn,
                   String categorySn, String skuSn, Long currentNum) {
        super();
        this.catalogId = catalogId;
        this.serviceId = serviceId;
        this.categoryId = categoryId;
        this.skuId = skuId;
        this.catalogSn = catalogSn;
        this.serviceSn = serviceSn;
        this.categorySn = categorySn;
        this.skuSn = skuSn;
        this.currentNum = currentNum;
    }

}
