package com.bocloud.cos.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 组件池
 *
 * @author lyy
 * @version 2.0
 * @time 2017年12月27日
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("portal_element_pool")
public class PortalElementPool extends Generic {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 组件名称
     */
    @Column("name")
    private String name;
    /**
     * 服务名称
     */
    @Column("server_name")
    private String serverName;
    /**
     * 组件类型
     */
    @Column("type")
    private String type;
    /**
     * 是否支持编辑
     */
    @Column("is_edit_enabled")
    private Boolean editEnabled;
    /**
     * 是否支持到处图片
     */
    @Column("is_export_image")
    private Boolean exportImage;
    /**
     * 组件描述
     */
    @Column("describe")
    private String describe;
    /**
     * 排序码
     */
    @Column("order_num")
    private int orderNum;
    /**
     * 图片
     */
    @Column("image")
    private String image;
    /**
     * url地址
     */
    @Column("url")
    private String url;
    /**
     * 编码
     */
    @Column("code")
    private String code;
    /**
     * 宽
     */
    @Column("width")
    private Integer width;
    /**
     * 高
     */
    @Column("height")
    private Integer height;
    /**
     * 是否有更多配置
     */
    @Column("more_config")
    private Boolean moreConfig;

    @IgnoreAll
    private List<PortalElementConfig> properties;

    public PortalElementPool(String name, String serverName, String type, Boolean editEnabled, Boolean exportImage,
                             String describe, int orderNum, String image, String url, String code) {
        super();
        this.name = name;
        this.serverName = serverName;
        this.type = type;
        this.editEnabled = editEnabled;
        this.exportImage = exportImage;
        this.describe = describe;
        this.orderNum = orderNum;
        this.image = image;
        this.url = url;
        this.code = code;
    }
}
