package com.bocloud.cos.entity;

import com.bocloud.common.utils.DateSerializer;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 首页配置
 *
 * @author lyy
 * @version 2.0
 * @time 2017年12月27日
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("portal_panel")
public class PortalPanel extends Generic {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 首页所有配置
     */
    @Column("config")
    private String config;
    /**
     * 坐标
     */
    @Column("location")
    private String location;
    /**
     * 服务名称
     */
    @Column("server_name")
    private String serverName;
    /**
     * 修改人id
     */
    @Column("mender_id")
    private Long menderId;
    /**
     * 修改时间
     */
    @Column("gmt_modify")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;
    /**
     * 创建时间
     */
    @Column("gmt_create")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    /**
     * 创建人
     */
    @Column("creator_id")
    private Long creatorId;
    @Column("tenant_id")
    private Long tenantId;
    /**
     * 是否删除
     */
    @Column("is_deleted")
    private Boolean deleted;

    @Column("project_id")
    private Long projectId;

    public PortalPanel(String config, String location, String serverName, Long menderId, Date gmtModify, Date gmtCreate,
                       Long creatorId, Long tenantId, Boolean deleted, Long projectId) {
        super();
        this.config = config;
        this.location = location;
        this.serverName = serverName;
        this.menderId = menderId;
        this.gmtModify = gmtModify;
        this.gmtCreate = gmtCreate;
        this.creatorId = creatorId;
        this.tenantId = tenantId;
        this.deleted = deleted;
        this.projectId = projectId;
    }
}
