package com.bocloud.cos.entity;

import com.bocloud.common.utils.DateSerializer;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("ros")
public class Ros extends GenericEntity {

    @PK(PKStrategy.AUTO)
    private Long id;// ID
    @Column("uuid")
    private String uuid;// UID
    @Column("sku_id")
    private Long skuId;// 商品ID
    @Column("service_code")
    private String serviceCode;// 服务code
    @Column("tenant_id")
    private Long tenantId;// 所属租户
    @Column("inventory")
    private String inventory;
    @Column("category_id")
    private Long categoryId; // 类型ID
    @Column("spec")
    private String spec; // 配置
    @Column("times")
    private Integer times; // 次数
    @Column("used")
    private Integer used; // 已使用
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column("expired_time")
    private Date expiredTime;// 过期时间
    @Column("gmt_catalog")
    private String gmtCatalog;
    @IgnoreAll
    private String tenantName;
    @IgnoreAll
    private String categoryName;

}
