package com.bocloud.cos.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 服务目录
 *
 * @author Administrator
 */
@Table("service_catalog")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
public class ServiceCatalog extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("code")
    private String code;
    @Column("sn")
    private String sn;
    @Column("icon")
    private String icon;

    /**
     * 是否有产品
     */
    @Column("has_category")
    private Boolean hasCategory;
    /**
     * 当前目录下的服务
     */
    @IgnoreAll
    private List<CloudService> cloudServices;

}
