package com.bocloud.cos.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 购物车
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2019/2/18
 */
@Data
@Table("shopping_cart")
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
public class ShoppingCart extends GenericEntity {

    /**
     * ID
     */
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 服务目录ID
     */
    @Column("service_id")
    private Long serviceId;
    /**
     * 资源申请类型
     */
    @Column("resource_category")
    private String resourceCategory;
    /**
     * 申请数量
     */
    @Column("count")
    private Integer count;
    /**
     * 申请时长(月)
     */
    @Column("months")
    private Integer months;
    /**
     * 清单
     */
    @Column("inventory")
    private String inventory;
    /**
     * 租户ID
     */
    @Column("tenant_id")
    private Long tenantId;
    /**
     * 项目ID
     */
    @Column("project_id")
    private Long projectId;
    /**
     * 服务目录名称
     */
    @IgnoreAll
    private String serviceName;

    @IgnoreAll
    private List<String> elementList;

}
