package com.bocloud.cos.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * SKU规格
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年3月10日
 */
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Table("sku_spec")
public class SkuSpec extends Generic {

    /**
     * id
     */
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 商品sku id
     */
    @Column("sku_id")
    private Long skuId;
    /**
     * 规格名称
     */
    @Column("spec_name")
    private String specName;
    /**
     * 规格值
     */
    @Column("spec_value")
    private String specValue;
    /**
     * 规格类型
     */
    @Column("spec_category")
    private String specCategory;
    /**
     * sku名称
     */
    @IgnoreAll
    private String skuName;
    /**
     * 商品类型ID
     */
    @IgnoreAll
    private Long categoryId;
    /**
     * 计费周期
     */
    @IgnoreAll
    private String period;
    /**
     * 产品sku状态
     */
    @IgnoreAll
    private String skuStatus;
    @IgnoreAll
    private String cpu;
    @IgnoreAll
    private String mem;
}
