package com.bocloud.cos.entity;

import com.bocloud.common.utils.DateDeserializer;
import com.bocloud.common.utils.DateSerializer;
import com.bocloud.entity.annotations.*;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 服务SLA实例
 *
 * @author Administrator
 */
@Table("sla_instance")
@Data
@NoArgsConstructor
public class SlaInstance extends Generic {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("name")
    private String name;
    @Column("content")
    private String content; // 协议内容
    @Column("gmt_create")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    @Column("creator_id")
    private Long createrId;
    @Column("service_id")
    private Long serviceId;
    @Column("sla_id")
    private Long slaId;
    @Column("order_id")
    private Long orderId;
    @IgnoreAll
    private String serviceName;
    @IgnoreAll
    private Long catalogId;
    @IgnoreAll
    private String catalogName;
    @IgnoreAll
    private String creatorName;

    public SlaInstance(String name, String content, Date gmtCreate, Long createrId, Long serviceId, Long slaId,
                       Long orderId) {
        super();
        this.name = name;
        this.content = content;
        this.gmtCreate = gmtCreate;
        this.createrId = createrId;
        this.serviceId = serviceId;
        this.slaId = slaId;
        this.orderId = orderId;
    }
}
