package com.bocloud.cos.enums;

/**
 * 平台状态
 *
 * @author weiwei
 */
public class BocloudStatus {

    public static enum Message {
        READ, // 已读
        UNREAD, // 未读
    }

    public static enum Alarm {
        UNCONFIRMED, // 未确认
        CONFIRMED, // 已确认
        SOLVED; // 已解决
    }

    public static enum Apply {
        UNAPPLY, // 未申请
        APPROVING, // 审批中
        APPROVED, // 已通过
        REFUSED,// 已拒绝
    }

    public static enum Power {
        RUNNING, // 运行中
        STARTING, // 开机中
        STOPPING, // 关机中
        STOPPED; // 关机
    }

    public static enum Basic {
        NORMAL, // 正常
        ABNORMAL, // 不可用
        ENABLED, // 启用
        DISABLED, // 未启用
        EXPIRED,//过期
        LOGOUT;//注销
    }

    public static enum Server {
        RUNNING, // 运行中
        STOPPED, // 关机
        STOPPING, // 关机中
        STARTING, // 开机中
        DEALLOCATEING,//解除释放中
        DEALLOCATE,//解除释放
        SUSPENDED, // 挂起
        SUSPENDING, // 挂起中
        ACTIVING, // 激活中
        PAUSED, // 停止
        PAUSING, // 停止中
        RECOVERING, // 恢复中
        EXCEPTION, // 异常
        BUILDING, // 创建中
        RESTARTING, // 重启中
        SOFTRESTARTING, // 软重启中
        EXPIRED, // 已过期
        SYNSEXCEPTION, // 同步异常
        RESIZING, // 修改配置中
        SYSTEMRESIZING, // 重装系统中
        SHELVED, // 搁置
        RESTORING, // 根磁盘快照还原中
        INACCESSIBLE, // 不可访问状态
        ERROR, // 错误
        UNKNOWN,// 未知
        VERIFYRESIZE;
    }

    public static enum Network {
        RUNNING, // 运行中
        INACTIVE, // 未激活
        CREATED, // 已创建
        STOPPED, // 停止
        BUILDING, // 创建中
        ERROR, // 错误
        EXCEPTION, // 异常
        PENDING_CREATE, // 等待创建
        PENDING_UPDATE, // 等待更新
        PENDING_DELETE;// 等待删除
    }

    public static enum Service {
        PUBLISHED, // 已发布
        UNPUBLISHED, // 未发布
        PUBLISH_APPROVING, // 发布审批中
        SOLDOUT, // 已下架
        SOLDOUT_APPROVING, // 下架审批中
        UNAPPLY, // 未申请
        APPLYING, // 申请中
        UNRATIFIED, // 未批准
        APPROVED, // 已通过
        USEING, // 使用中
        EXPIRED, // 已过期
        IMMINENT_EXPIRY, // 即将过期
        POSTPONE_APPOVING;// 延期申请中
    }

    public static enum Image {
        PUBLIC,  // 公有镜像
        PRIVATE;  // 私有镜像
    }
}
