package com.bocloud.cos.enums;

/**
 * 计费公共枚举
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年3月16日
 */
public class ChargeCommon {

    /**
     * 计费模式
     *
     * @author wangyu
     * @version 1.0
     * @since 2020年3月16日
     */
    public enum ChargeMode {
        PreCharge, // 预付费
        PostCharge// 后付费
    }

    /**
     * 订单资源状态
     *
     * @author wangyu
     * @version 1.0
     * @since 2020年3月16日
     */
    public enum ResourceStatus {
        /**
         * 创建中
         */
        creating,
        /**
         * 变更中
         */
        changing,
        /**
         * 创建完成
         */
        ready,
        /**
         * 创建失败
         */
        failed,
        /**
         * 异常
         */
        exception,
        /**
         * 已取消
         */
        canceld,
        /**
         * 已完成
         */
        finish;
    }

    /**
     * 订单状态
     *
     * @author wangyu
     * @version 1.0
     * @since 2020年3月16日
     */
    public enum OrderStatus {
        /**
         * 未支付
         */
        unpay,
        /**
         * 已支付
         */
        paid,
        /**
         * 已取消
         */
        canceld,
        /**
         * 待审批
         */
        audit
    }

    /**
     * @author wangyu
     * @version 1.0
     * @since 2020年4月14日
     */
    public enum BillStatus {
        unpay, // 未支付
        paid, // 已支付
        paying, // 支付中
        canceld// 已取消
    }

    /**
     * 订单/账单类型
     */
    public enum Type {
        /**
         * 新购
         */
        apply,
        /**
         * 变更
         */
        alterat,
        /**
         * 延期
         */
        extension,
        /**
         * 退订
         */
        unsubscribe
    }

    public enum CarStatus {
        /**
         * 已下单
         */
        order,
        /**
         * 未下单
         */
        noOrder,
    }
}
