package com.bocloud.cos.enums;

import lombok.Getter;

/**
 * 子订单状态
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年4月14日
 */
@Getter
public enum OrderItemStatus {

    OpenedSuccess("OpenedSuccess", "开通成功"),
    OpenedFailure("OpenedFailure", "开通失败"),
    Opening("Opening", "正在开通"),
    ChangeSuccess("ChangeSuccess", "变更成功"),
    ChangeFailure("ChangeFailure", "变更失败"),
    Changing("Changing", "正在变更"),
    UnsubscribeSuccess("UnsubscribeSuccess", "退订成功"),
    UnsubscribeFailure("UnsubscribeFailure", "退订失败"),
    Unsubscribing("Unsubscribing", "正在退订"),
    ExtensionSuccess("ExtensionSuccess", "延期成功"),
    ExtensionFailure("ExtensionFailure", "延期失败"),
    Extensioning("Extensioning", "延期中"),
    Abandoned("Abandoned", "已作废"),
    Canceld("Canceld", "已取消"),
    Termination("Termination", "已终止"),
    Audit("Audit", "待审批");

    String code;
    String msg;

    OrderItemStatus(String code, String msg) {
        this.msg = msg;
        this.code = code;
    }

    public static OrderItemStatus getMsg(String code) {
        for (OrderItemStatus c : OrderItemStatus.values()) {
            if (c.getCode().equalsIgnoreCase(code)) {
                return c;
            }
        }
        return null;
    }
}
