package com.bocloud.cos.internel.entity;

import com.bocloud.common.utils.DateSerializer;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 消息队列服务
 *
 * @author weiwei
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("cms")
public class Cms extends GenericEntity {

    @PK(PKStrategy.AUTO)
    private Long id;// ID
    @Column("uuid")
    private String uuid;// UUID
    @Column("instance_id")
    private String instanceId;// 实例UUID
    @Column("type")
    private String type;// 类型
    @Column("category")
    private String category;// 部署类型
    @Column("version")
    private String version;// 版本
    @Column("sku_id")
    private Long skuId;// 商品ID
    @Column("network_id")
    private Long networkId;// 网络ID
    @Column("region")
    private String region;// 所属域
    @Column("tenant_id")
    private Long tenantId;// 所属租户
    @Column("inventory")
    private String inventory;
    @Column("category_id")
    private Long categoryId; // 类型ID
    @Column("spec")
    private String spec; // 配置
    @Column("address")
    private String address;
    @Column("username")
    private String username;
    @Column("password")
    private String password;
    @Column("manage_ip")
    private String manageIp;
    @Column("topics")
    private Integer topics;
    @Column("gmt_catalog")
    private String gmtCatalog;
    @Column("task_id")
    private Long taskId;
    @Column("vendor_id")
    private Long vendorId;
    @Column("project_id")
    private Long projectId;
    @IgnoreAll
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date expiredTime;// 过期时间
    @IgnoreAll
    private String categoryName;
    @IgnoreAll
    private Long diskSkuId;
    @IgnoreAll
    private Integer dataDisk;
    @IgnoreAll
    private String diskCategory;
    @IgnoreAll
    private List<Map<String, String>> connections;
    @IgnoreAll
    private String tenantName;

    /**
     * @param uuid
     * @param type
     * @param version
     * @param skuId
     * @param networkId
     * @param region
     * @param tenantId
     */
    public Cms(String uuid, String type, String version, Long skuId, Long networkId, String region, Long tenantId) {
        super();
        this.uuid = uuid;
        this.type = type;
        this.version = version;
        this.skuId = skuId;
        this.networkId = networkId;
        this.region = region;
        this.tenantId = tenantId;
    }

    public Cms(String name, String status, Long creatorId, String instanceId, String type, String category,
               String version, Long tenantId, String username, String password, String gmtCatalog, Long taskId) {
        super();
        this.setName(name);
        this.setStatus(status);
        this.setCreatorId(creatorId);
        this.instanceId = instanceId;
        this.type = type;
        this.category = category;
        this.version = version;
        this.tenantId = tenantId;
        this.username = username;
        this.password = password;
        this.gmtCatalog = gmtCatalog;
        this.taskId = taskId;
    }

}
