package com.bocloud.cos.internel.entity;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;

import java.util.List;

/**
 * 字典实体类
 *
 * @author dmw
 */
@Table("dictionary")
public class Dictionary extends Generic {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("pvalue")
    private String pvalue;
    @Column("name")
    private String name;
    @Column("value")
    private String value;// value
    @IgnoreAll
    private String children;
    @IgnoreAll
    private List<Dictionary> childrenList;

    /**
     * @return the id
     */
    public Long getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * @return the pvalue
     */
    public String getPvalue() {
        return pvalue;
    }

    /**
     * @param pvalue the pvalue to set
     */
    public void setPvalue(String pvalue) {
        this.pvalue = pvalue;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the value
     */
    public String getValue() {
        return value;
    }

    /**
     * @param value the value to set
     */
    public void setValue(String value) {
        this.value = value;
    }

    /**
     * @return the children
     */
    public String getChildren() {
        return children;
    }

    /**
     * @param children the children to set
     */
    public void setChildren(String children) {
        this.children = children;
    }

    /**
     * @param id
     * @param pid
     * @param name
     * @param value
     */
    public Dictionary(Long id, String pvalue, String name, String value) {
        super();
        this.id = id;
        this.pvalue = pvalue;
        this.name = name;
        this.value = value;
    }

    /**
     *
     */
    public Dictionary() {
        super();
    }

    /*
     * (non-Javadoc)
     *
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

    /**
     * @return the childrenList
     */
    public List<Dictionary> getChildrenList() {
        return childrenList;
    }

    /**
     * @param childrenList the childrenList to set
     */
    public void setChildrenList(List<Dictionary> childrenList) {
        this.childrenList = childrenList;
    }

}
