package com.bocloud.cos.internel.entity;

import com.bocloud.common.utils.DaySerializer;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * openstack浮动IP类
 *
 * @author wangyu
 * @version 1.0
 * @since 2017年8月28日
 */
@Table("floating_ip")
public class FloatingIp extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("floating_ip_uuid")
    private String floatingIpUuid;
    @Column("router_uuid")
    private String routerUuid;
    @Column("tenant_uuid")
    private String tenantUuid;
    @Column("floating_network_uuid")
    private String floatingNetworkUuid;
    @Column("floating_ip_address")
    private String floatingIpAddress;
    @Column("fixed_ip_address")
    private String fixedIpAddress;
    @Column("port_uuid")
    private String portUuid;
    @Column("uuid")
    private String uuid;
    @Column("router_id")
    private Long routerId;
    @Column("port_id")
    private Long portId;
    @Column("network_id")
    private Long networkId;
    @Column("vendor_id")
    private Long vendorId;
    @Column("tenant_id")
    private Long tenantId;// 租户ID
    @Column("project_id")
    private Long projectId;// 项目ID
    @Column("instance_id")
    private String instanceId;
    @Column("networkcard_uuid")
    private String networkCardUuid;
    @IgnoreAll
    private String vendorName;
    @IgnoreAll
    private String networkName;
    @IgnoreAll
    private String tenantName;// 租户名称
    @IgnoreAll
    private String projectName;// 项目名称
    @IgnoreAll
    private String projectVisibility;
    @IgnoreAll
    private String targetName;// 租户用户
    @IgnoreAll
    @JsonSerialize(using = DaySerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date expiredTime;// 过期时间
    @Column("region_id")
    private String regionId;
    @IgnoreAll
    private String regionName;
    @IgnoreAll
    private Integer count;
    @IgnoreAll
    private String serverName;
    @IgnoreAll
    private String osTenantName;// openstack底层租户
    @IgnoreAll
    private String resourceGroupUuid;

    /**
     * @return the id
     */
    public Long getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * @return the floatingIpUuid
     */
    public String getFloatingIpUuid() {
        return floatingIpUuid;
    }

    /**
     * @param floatingIpUuid the floatingIpUuid to set
     */
    public void setFloatingIpUuid(String floatingIpUuid) {
        this.floatingIpUuid = floatingIpUuid;
    }

    /**
     * @return the routerUuid
     */
    public String getRouterUuid() {
        return routerUuid;
    }

    /**
     * @param routerUuid the routerUuid to set
     */
    public void setRouterUuid(String routerUuid) {
        this.routerUuid = routerUuid;
    }

    /**
     * @return the tenantUuid
     */
    public String getTenantUuid() {
        return tenantUuid;
    }

    /**
     * @param tenantUuid the tenantUuid to set
     */
    public void setTenantUuid(String tenantUuid) {
        this.tenantUuid = tenantUuid;
    }

    /**
     * @return the floatingNetworkUuid
     */
    public String getFloatingNetworkUuid() {
        return floatingNetworkUuid;
    }

    /**
     * @param floatingNetworkUuid the floatingNetworkUuid to set
     */
    public void setFloatingNetworkUuid(String floatingNetworkUuid) {
        this.floatingNetworkUuid = floatingNetworkUuid;
    }

    /**
     * @return the floatingIpAddress
     */
    public String getFloatingIpAddress() {
        return floatingIpAddress;
    }

    /**
     * @param floatingIpAddress the floatingIpAddress to set
     */
    public void setFloatingIpAddress(String floatingIpAddress) {
        this.floatingIpAddress = floatingIpAddress;
    }

    /**
     * @return the fixedIpAddress
     */
    public String getFixedIpAddress() {
        return fixedIpAddress;
    }

    /**
     * @param fixedIpAddress the fixedIpAddress to set
     */
    public void setFixedIpAddress(String fixedIpAddress) {
        this.fixedIpAddress = fixedIpAddress;
    }

    /**
     * @return the portUuid
     */
    public String getPortUuid() {
        return portUuid;
    }

    /**
     * @param portUuid the portUuid to set
     */
    public void setPortUuid(String portUuid) {
        this.portUuid = portUuid;
    }

    /**
     * @return the routerId
     */
    public Long getRouterId() {
        return routerId;
    }

    /**
     * @param routerId the routerId to set
     */
    public void setRouterId(Long routerId) {
        this.routerId = routerId;
    }

    /**
     * @return the portId
     */
    public Long getPortId() {
        return portId;
    }

    /**
     * @param portId the portId to set
     */
    public void setPortId(Long portId) {
        this.portId = portId;
    }

    /**
     * @return the networkId
     */
    public Long getNetworkId() {
        return networkId;
    }

    /**
     * @param networkId the networkId to set
     */
    public void setNetworkId(Long networkId) {
        this.networkId = networkId;
    }

    /**
     * @return the vendorId
     */
    public Long getVendorId() {
        return vendorId;
    }

    /**
     * @param vendorId the vendorId to set
     */
    public void setVendorId(Long vendorId) {
        this.vendorId = vendorId;
    }

    /**
     * @return the vendorName
     */
    public String getVendorName() {
        return vendorName;
    }

    /**
     * @param vendorName the vendorName to set
     */
    public void setVendorName(String vendorName) {
        this.vendorName = vendorName;
    }

    /**
     * @return the networkName
     */
    public String getNetworkName() {
        return networkName;
    }

    /**
     * @param networkName the networkName to set
     */
    public void setNetworkName(String networkName) {
        this.networkName = networkName;
    }

    /**
     * @return the tenantId
     */
    public Long getTenantId() {
        return tenantId;
    }

    /**
     * @param tenantId the tenantId to set
     */
    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    /**
     * @return the tenantName
     */
    public String getTenantName() {
        return tenantName;
    }

    /**
     * @param tenantName the tenantName to set
     */
    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    /**
     * @return the expiredTime
     */
    public Date getExpiredTime() {
        return expiredTime;
    }

    /**
     * @param expiredTime the expiredTime to set
     */
    public void setExpiredTime(Date expiredTime) {
        this.expiredTime = expiredTime;
    }

    /**
     * @return the projectId
     */
    public Long getProjectId() {
        return projectId;
    }

    /**
     * @param projectId the projectId to set
     */
    public void setProjectId(Long projectId) {
        this.projectId = projectId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getTargetName() {
        return targetName;
    }

    public void setTargetName(String targetName) {
        this.targetName = targetName;
    }

    public FloatingIp() {
        super();
    }

    public void preSave(Long creatorId, Long menderId, Long vendorId, Long networkId, Long tenantId, Long projectId) {
        this.setCreatorId(creatorId);
        this.setMenderId(menderId);
        this.setVendorId(vendorId);
        this.setNetworkId(networkId);
        this.setTenantId(tenantId);
        this.setProjectId(projectId);
    }

    public String getRegionId() {
        return regionId;
    }

    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    public String getRegionName() {
        return regionName;
    }

    public void setRegionName(String regionName) {
        this.regionName = regionName;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    public String getInstanceId() {
        return instanceId;
    }

    public void setInstanceId(String instanceId) {
        this.instanceId = instanceId;
    }

    public String getNetworkCardUuid() {
        return networkCardUuid;
    }

    public void setNetworkCardUuid(String networkCardUuid) {
        this.networkCardUuid = networkCardUuid;
    }

    public String getServerName() {
        return serverName;
    }

    public void setServerName(String serverName) {
        this.serverName = serverName;
    }

    public String getProjectVisibility() {
        return projectVisibility;
    }

    public void setProjectVisibility(String projectVisibility) {
        this.projectVisibility = projectVisibility;
    }

    public String getOsTenantName() {
        return osTenantName;
    }

    public void setOsTenantName(String osTenantName) {
        this.osTenantName = osTenantName;
    }

    public String getUuid() {
        return uuid;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }

    public String getResourceGroupUuid() {
        return resourceGroupUuid;
    }

    public void setResourceGroupUuid(String resourceGroupUuid) {
        this.resourceGroupUuid = resourceGroupUuid;
    }

}
