package com.bocloud.cos.internel.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.math.BigInteger;

/**
 * @author wangyu
 * @version 5.1.0
 * @description IP池管理
 * @date: 2020-11-30
 */
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@Table("ip_pool")
public class IpPool extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("gateway")
    private String gateway; // 网关
    @Column("cidr")
    private String cidr; // cidr
    @Column("pools")
    private String pools; // IP池范围
    @Column("dns_names")
    private String dnsNames; // DNS
    @Column("subnet_id")
    private Long subnetId; // 子网ID
    @Column("network_id")
    private Long networkId; // 网络ID
    @Column("vendor_id")
    private Long vendorId; // 平台ID
    @Column("vlan_id")
    private Integer vlanId; // vlan id
    @Column("version")
    private String version; // IP协议版本:V4/V6s
    @Column("router_port_id")
    private Long routerPortId;// nsx路由器端口id
    @Column("port_group_id")
    private Long portGroupId;// 关联的vc端口组id
    @Column("segment_id")
    private Long segmentId;// nsx分段id
    @IgnoreAll
    private String vendorName; // 平台名称
    @IgnoreAll
    private String subnetName; // 子网名称
    @IgnoreAll
    private String vendorType; // 平台类型
    @IgnoreAll
    private BigInteger ipTotal; // ip总数
    @IgnoreAll
    private Long ipUsed; // ip使用数
    @IgnoreAll
    private BigInteger ipFree; // ip剩余数

    public IpPool(String gateway, String cidr, String pools, String dnsNames, Long subnetId, Long networkId,
                  Long vendorId) {
        this.gateway = gateway;
        this.cidr = cidr;
        this.pools = pools;
        this.dnsNames = dnsNames;
        this.subnetId = subnetId;
        this.networkId = networkId;
        this.vendorId = vendorId;
    }
}
