package com.bocloud.cos.internel.entity;

import com.bocloud.common.utils.DateDeserializer;
import com.bocloud.common.utils.DateSerializer;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * 管理员用户
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年1月29日
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("manager")
public class Manager extends GenericEntity {
    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("account")
    private String account; // 账号
    @Column("password")
    private String password; // 密码
    @Column("email")
    private String email; // 邮件
    @Column("phone")
    private String phone; // 电话
    @Column("mobile")
    private String mobile; // 移动电话
    @Column("login_status")
    private Boolean loginStatus; // 登录状态
    @Column("company")
    private String company; // 公司
    @Column("session_id")
    private String sessionId; // sessionId
    @Column("depart_id")
    private Long departId; // 组织机构ID
    @Column("depart_ids")
    private String departIds;
    @Column("job_number")
    private String jobNumber;// 工号
    @Column("sex")
    private Boolean sex;// 性别
    @Column("portrait")
    private String portrait;// 头像
    @Column("origin")
    private String origin;
    @Column("last_pwd_modify_date")
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lastPwdModifyDate;// 最后一次密码修改时间
    @Column("last_login_date")
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lastLoginDate;// 最后一次登录时间
    @Column("expired_date")
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date expiredDate;//过期时间
    @IgnoreAll
    private String departName;// 组织机构名称
    @IgnoreAll
    private Boolean checked;
    @IgnoreAll
    private List<String> roleNames;
}
