package com.bocloud.cos.internel.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 自服务端权限实体类
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年1月29日
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("permission")
public class Permission extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("parent_id")
    private Long parentId; // 父节点
    @Column("is_tenant")
    private Boolean tenant;// 是否为租户权限
    @Column("path")
    private String path; // 路由地址
    @Column("icon")
    private String icon; // 图标
    @Column("category")
    private String category;// 类型
    @Column("priority")
    private Integer priority;// 优先级
    @Column("router")
    private String router;// 路由名称
    @Column("component")
    private String component;// 组件名称
    @Column("redirect")
    private String redirect;// 重定向地址
    @Column("meta")
    private String meta;// META设置
    @Column("params")
    private String params;// PARAMS设置
    @Column("service_codes")
    private String serviceCodes;// 服务编码
    @IgnoreAll
    private String children;
    @IgnoreAll
    private boolean checked;
    @IgnoreAll
    private List<Permission> childs;
}
