package com.bocloud.cos.internel.entity;

import com.alibaba.fastjson.JSONArray;
import com.bocloud.cos.entity.ResourceQuota;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;

import java.util.List;

@Table("project")
public class Project extends GenericEntity {

    @PK(PKStrategy.AUTO)
    private Long id;// ID
    @Column("visibility")
    private String visibility;//可见性(内部项目/公共项目/默认项目)
    @Column("tenant_id")
    private Long tenantId;// 租户ID
    @Column("business_id")
    private Long businessId;//所属业务ID
    @Column("code")
    private String code;//编码
    @IgnoreAll
    private JSONArray quotas;// 配额
    @IgnoreAll
    private String tenantName;// 租户名称
    @IgnoreAll
    private int resourceNum;// 资源数量
    @IgnoreAll
    private Long managerId;//项目负责人ID
    @IgnoreAll
    private String managerName;//项目负责人名称
    @IgnoreAll
    private Integer userCount;//用户数
    @IgnoreAll
    private String businessName;
    @IgnoreAll
    private List<ResourceQuota> resourceQuotas;//租户配额

    /**
     *
     */
    public Project() {
        super();
    }

    /**
     * @param visibility
     * @param tenantId
     */
    public Project(String visibility, Long tenantId) {
        this.visibility = visibility;
        this.tenantId = tenantId;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getVisibility() {
        return visibility;
    }

    public void setVisibility(String visibility) {
        this.visibility = visibility;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public JSONArray getQuotas() {
        return quotas;
    }

    public void setQuotas(JSONArray quotas) {
        this.quotas = quotas;
    }

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public int getResourceNum() {
        return resourceNum;
    }

    public void setResourceNum(int resourceNum) {
        this.resourceNum = resourceNum;
    }

    public Long getManagerId() {
        return managerId;
    }

    public void setManagerId(Long managerId) {
        this.managerId = managerId;
    }

    public String getManagerName() {
        return managerName;
    }

    public void setManagerName(String managerName) {
        this.managerName = managerName;
    }

    public Integer getUserCount() {
        return userCount;
    }

    public void setUserCount(Integer userCount) {
        this.userCount = userCount;
    }

    public Long getBusinessId() {
        return businessId;
    }

    public void setBusinessId(Long businessId) {
        this.businessId = businessId;
    }

    public String getBusinessName() {
        return businessName;
    }

    public void setBusinessName(String businessName) {
        this.businessName = businessName;
    }

    public List<ResourceQuota> getResourceQuotas() {
        return resourceQuotas;
    }

    public void setResourceQuotas(List<ResourceQuota> resourceQuotas) {
        this.resourceQuotas = resourceQuotas;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }
}
