package com.bocloud.cos.model;

import com.bocloud.common.model.RequestContext;
import com.bocloud.cos.enums.OrderItemStatus;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 退订参数
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年4月14日
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class CancelationParam {

    /**
     * 服务编码
     */
    private String service;
    /**
     * 实例id
     */
    private String instance;
    /**
     * 服务类型
     */
    private String category;
    /**
     * 退订人
     */
    private RequestContext context;
    /**
     * 退订的机器
     */
    private List<String> instances;
    /**
     * 旧订单明细状态
     */
    private OrderItemStatus oldStatus;
    /**
     * 用于前端回显实例数据
     */
    private String preview;
    /**
     * 实例名称
     */
    private String instanceName;
}
