package com.bocloud.cos.model;

import com.alibaba.fastjson.JSONObject;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

/**
 * sku数据模型
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年4月13日
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ElementModel {

    /**
     * SkuId
     */
    private Long skuId;
    /**
     * 申请数量
     */
    private Integer count;
    /**
     * 折扣率
     */
    private BigDecimal ratio;
    /**
     * 商品价格
     */
    private BigDecimal price;
    /**
     * 服务编码
     */
    private String serviceCode;
    /**
     * 规格详情
     */
    private List<SpecModel> specs;

    private Long categoryId;
    /**
     * 类型
     */
    private String category;
    /**
     * element uuid，用于标识磁盘
     */
    private String uuid;
    /**
     * 更多的节点属性，例如bootVolume是否是系统盘等属性
     */
    private JSONObject props;
}
