package com.bocloud.cos.model;

import com.bocloud.common.model.RequestContext;
import com.bocloud.cos.enums.OrderItemStatus;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 服务延期参数
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年4月14日
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ExtensionParam {

    /**
     * 服务编码
     */
    private String service;
    /**
     * 实例id
     */
    private String instance;
    /**
     * 实例名称
     */
    private String instanceName;
    /**
     * 延期时长
     */
    private Integer extension;
    /**
     * 单位
     */
    private DurationModel.Mode mode;
    /**
     * 服务类型
     */
    private String category;
    /**
     * 延期操作者
     */
    private RequestContext context;
    /**
     * 旧订单状态
     */
    private OrderItemStatus oldStatus;
    /**
     * 用于前端回显实例数据
     */
    private String preview;
}
