package com.bocloud.cos.model;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @author tyl
 * @time 2020/4/8 周三 12:07
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class QuotaModel {
    private String catalogName;//服务目录名
    private String sn;//服务目录排序
    private List<Quota> quota;//服务配额

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    public static class Quota {
        private String serviceName;
        private QuotaDetail quotaDetail;

        @Data
        @AllArgsConstructor
        @NoArgsConstructor
        public static class QuotaDetail {
            private String quotaName;
            //项目已使用配额
            private Long used;
            //租户分配配额
            private Long assigned;
            //项目分配配额
            private Long projectAssigned;
            //项目未使用配额
            private Long projectFree;
            //剩余未分配配额
            private Long free;
            //总配额
            private Long quota;
            //配额单位
            private String unit;
        }
    }
}

