package com.bocloud.cos.model;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

/**
 * 服务基础价格
 *
 * @author tyl
 * @since 2021/4/25 17:15
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ServicePrice {
    /**
     * 计费项
     */
    private String name;
    /**
     * 规格单位
     */
    private String spec;

    /**
     * 规格名称
     */
    private String specName;

    /**
     * 规格数量
     */
    private Integer number;
    /**
     * 每小时价格
     */
    private BigDecimal hourPrice;
    /**
     * 每月价格
     */
    private BigDecimal monthPrice;
    /**
     * 每年价格
     */
    private BigDecimal yearPrice;

    public static BigDecimal getPrice(DurationModel.Mode durationMode, ServicePrice servicePrice) {
        switch (durationMode) {
            case Hour:
                return servicePrice.getHourPrice();
            case Month:
                return servicePrice.getMonthPrice();
            default:
                return servicePrice.getYearPrice();
        }
    }
}
