package com.bocloud.cos.params;

import com.bocloud.common.utils.DateSerializer;
import com.bocloud.entity.annotations.IgnoreUpdate;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author tyl
 * @since 2021/3/26 16:19
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class WorkOrderParams {
    private Long id;
    private String name;
    private String remark;
    private String status;
    private String catalog;
    private String phone;
    private String email;
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date reportTime;
    private Long tenantId;
    private String content;
    private Integer star;
    private String orderItemSn;
    private String instanceUuid;
    private String resourceCatalog;
    private String resourceCategory;
}
