package com.bocloud.cos.repository;

import com.bocloud.common.utils.MapTools;
import com.bocloud.cos.entity.Attachment;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.Arrays;
import java.util.List;

@Repository
public class AttachmentRepository extends BasicGenericDao<Attachment, Long> {

    public AttachmentRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public List<Attachment> list(String... groupIds) {
        try {
            String sql = "select * from attachment where deleted = 0 and group_id in (:groupIds) ";
            return this.list(Attachment.class, sql, MapTools.simpleMap("groupIds", Arrays.asList(groupIds)));
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public void saveAttachment(List<Attachment> attachments) {
        try {
            this.batchSave(attachments, 1000);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
