package com.bocloud.cos.repository;

import com.bocloud.common.utils.Common;
import com.bocloud.common.utils.MapTools;
import com.bocloud.cos.entity.MessageRecord;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class MessageRecordRepository extends BasicGenericDao<MessageRecord, Long> {

    public MessageRecordRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public MessageRecord get(Long userId, String category) {
        String sql = "select * from message_record where user_id = :userId and category = :category";
        Map<String, Object> params = MapTools.simpleMap(Common.USERID, userId);
        params.put("category", category);
        List<MessageRecord> records = this.list(MessageRecord.class, sql, params);
        return records.isEmpty() ? null : records.get(0);
    }

}
