package com.bocloud.cos.repository;

import com.bocloud.common.utils.MapTools;
import com.bocloud.cos.entity.PortalElementPool;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author lyy
 */
@Service
public class PortalElementPoolRepository extends BasicGenericDao<PortalElementPool, Long> {

    public PortalElementPoolRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public List<PortalElementPool> listPortalElementPool(String serverName) {
        String sql = "select * from portal_element_pool where server_name = :serverName order by order_num";
        Map<String, Object> params = MapTools.simpleMap("serverName", serverName);
        return this.list(PortalElementPool.class, sql, params);
    }

}
