package com.bocloud.cos.context;

import com.bocloud.cos.entity.*;
import com.bocloud.cos.enums.ResourceCategory;
import com.bocloud.cos.model.ApplicationParam;
import com.bocloud.cos.operate.ResourceOperate;
import com.bocloud.cos.internel.entity.Tenant;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class ApplicationContext {

    /**
     * 订购参数
     */
    private ApplicationParam params;
    /**
     * 服务
     */
    private CloudService service;
    /**
     * SLA ID
     */
    private Long slaId;
    /**
     * SLA
     */
    private ServiceSla sla;
    /**
     * SKU ID
     */
    private Long skuId;
    /**
     * SKU
     */
    private ServiceSku sku;
    /**
     * 服务类型
     */
    private ServiceCategory category;
    /**
     * 订单
     */
    private ServiceOrder serviceOrder;
    /**
     * operate
     */
    private ResourceOperate operate;
    /**
     * 资源类型
     */
    private ResourceCategory resourceCategory;
    /**
     * 申请所属租户
     */
    private Tenant tenant;

    /**
     * 配额
     */
    List<ResourceQuota> resourceQuotas;

}
