package com.bocloud.cos.internal;

import com.bocloud.common.enums.BoCloudMethod;
import com.bocloud.common.enums.BoCloudService;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.BocloudToken;
import com.bocloud.common.model.Pager;
import com.bocloud.common.model.Param;
import com.bocloud.service.core.CurrentService;
import com.bocloud.service.core.Service;
import com.bocloud.service.http.core.ServiceFactory;
import com.bocloud.service.http.model.RemoteService;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.Assert;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by liuyuanyuan on 2020/7/14 20:12
 */
@Component
public class ImsVolumePoolService implements InitializingBean {
    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private CurrentService currentService;
    private static Service service = Service.create(BoCloudService.IMS);
    private Map<String, Object> headers = new HashMap<>(4);

    public BocloudResult listByStoragePools(int page, int rows, List<Param> params, Map<String, String> sorter) {
        Pager pager = new Pager(page, rows, params, sorter);
        RemoteService remote = serviceFactory.build(service, "/v1/storages/pools", BoCloudMethod.GET, headers,
                pager.toMap());
        BocloudResult result = remote.invoke();
        if (result.isFailed()) {
            return new BocloudResult(false, result.getMessage());
        }
        Assert.notNull(result.getData(), "获取存储信息失败");
        return result;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        this.headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        this.headers.put("source", currentService.getService().getName());
    }
}
