package com.bocloud.cos.intf;

import com.bocloud.common.model.BocloudResult;

/**
 * 账单分析业务接口
 *
 * @author tyl
 * @time 2020/6/29 周一 16:38
 */
public interface BillAnalysisService {
    /**
     * 收入概览
     *
     * @return
     */
    BocloudResult incomeOverview();

    /**
     * 收入分析
     *
     * @param params
     * @return
     */
    BocloudResult billsAnalysis(Long vendorId, String time, String serviceCode, String condition);

    /**
     * @param time      两种方式传参1.{"startTime":"2021-05-21 00:00:00","endTime":"2022-02-21 00:00:00"} 2.{"time":"Months"}
     * @param condition 类别 ：平台vendor 租户tenant 业务business 项目project 标签label
     * @return com.bocloud.common.model.BocloudResult
     * @Author: lxy
     * @Description: 账单分析
     * @Date 2021/5/27 19:02
     * @throws:
     **/
    BocloudResult billsAnalysisNew(String time, String condition, String label);

    /**
     * @return com.bocloud.common.model.BocloudResult
     * @Author: lxy
     * @Description: 用户消费TOP5
     * @Date 2021/5/31 11:21
     * @Param
     * @throws:
     **/
    BocloudResult getUserTop5();

    BocloudResult billsAnalysisNewDownload(String time, String condition, String label);
}
