package com.bocloud.cos.intf;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Param;
import com.bocloud.common.model.RequestContext;
import com.bocloud.cos.model.ApplicationParam;
import com.bocloud.cos.params.CosParams;

import java.util.List;
import java.util.Map;

/**
 * 运维服务业务接口
 *
 * @author weiwei
 */
public interface CosService {

    /**
     * 查询列表
     *
     * @param page
     * @param rows
     * @param params
     * @param sorter
     * @param simple
     * @param context
     * @return
     */
    BocloudResult list(int page, int rows, List<Param> params, Map<String, String> sorter, boolean simple,
                       RequestContext context);

    /**
     * 查询详情
     *
     * @param id
     * @return
     */
    BocloudResult detail(Long id);

    /**
     * 删除
     *
     * @param id
     * @param context
     * @return
     */
    BocloudResult remove(Long id, RequestContext context);

    BocloudResult create(ApplicationParam param, RequestContext context);

    BocloudResult execute(CosParams params, RequestContext context);

}
