package com.bocloud.cos.intf;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.RequestContext;

/**
 * 订单分析业务接口
 *
 * @author tyl
 * @time 2020/6/23 周二 11:03
 */
public interface OrderAnalysisService {

    /**
     * 订单分析概览
     *
     * @return
     */
    BocloudResult getOrdersOverview(Long vendorId, String time, String startTime, String endTime, Boolean owner, RequestContext context);

    /**
     * 订单数量统计（首页）
     *
     * @return
     */
    BocloudResult ordersCount();

    /**
     * 平台订单分析
     *
     * @param condition
     * @param time
     * @return
     */
    BocloudResult vendorOrderAnalyse(String condition, String time, String startTime, String endTime);

    /**
     * 租户订单分析
     *
     * @param tenantId
     * @param condition
     * @param time
     * @return
     */
    BocloudResult tenantOrderAnalyse(Long tenantId, String condition, String time, String startTime, String endTime);

    /**
     * 订单状态分析
     *
     * @param time
     * @param status
     * @param condition
     * @return
     */
    BocloudResult orderStatusAnalyse(String time, String startTime, String endTime, String status, String condition);

    /**
     * 订单类型分析
     *
     * @param time
     * @param type
     * @param condition
     * @return
     */
    BocloudResult orderTypeAnalyse(String time, String startTime, String endTime, String type, String condition);

    /**
     * 订单类型分析
     *
     * @param time
     * @param serviceCode
     * @param condition
     * @return
     */
    BocloudResult resourceOrderAnalyse(String time, String startTime, String endTime, String serviceCode, String condition);

}
