package com.bocloud.cos.intf;

import com.bocloud.common.model.*;
import com.bocloud.cos.entity.Payment;

/**
 * 支付记录接口
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年3月10日
 */
public interface PaymentService {

    /**
     * 查询列表
     *
     * @param pager
     * @param context
     * @return
     */
    BocloudResult<GridBean<Payment>> list(Pager pager, RequestContext context);

    /**
     * 创建
     *
     * @param payment
     * @param context
     * @return
     */
    Result create(Payment payment, RequestContext context);

    /**
     * 修改
     *
     * @param payment
     * @param context
     * @return
     */
    Result modify(Payment payment, RequestContext context);

    /**
     * 查询详情
     *
     * @param id
     * @return
     */
    BocloudResult<Payment> detail(Long id);

    /**
     * 删除
     *
     * @param id
     * @param context
     * @return
     */
    Result remove(Long id, RequestContext context);
}
