package com.bocloud.cos.intf;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Pager;

/**
 * 资源分析业务接口
 *
 * @author tyl
 * @time 2020/6/29 周一 16:37
 */
public interface ResourceAnalysisService {
    /**
     * 资源统计
     *
     * @param vendor
     * @param centerId
     * @param clusterId
     * @return
     */
    BocloudResult resourceStatistics(Long vendor, Long centerId, Long clusterId, String condition);

    /**
     * 状态分析
     *
     * @param vendor
     * @param centerId
     * @param clusterId
     * @return
     */
    BocloudResult resourceStatus(Long vendor, Long centerId, Long clusterId, String condition);

    /**
     * 容量分析
     *
     * @param vendorId
     * @param vdcId
     * @param clusterId
     * @param time
     * @param resourceType
     * @param condition
     * @return
     */
    BocloudResult resourceCapacity(Long vendorId, Long vdcId, Long clusterId, String time, String resourceType,
                                   String condition);

    /**
     * @param vdcId
     * @param clusterId
     * @return com.bocloud.common.model.BocloudResult
     * @Author: lxy
     * @Description: 云平台资源统计
     * @Date 2021/5/26 11:43
     * @Param vendorId
     * @throws:
     **/
    BocloudResult getAllCloudCount(Long vendorId, Long vdcId, Long clusterId);

    /**
     * @param vdcId
     * @param clusterId
     * @param time
     * @param resourceType 针对容量使用趋势（cpu、mem、disk）
     * @return com.bocloud.common.model.BocloudResult
     * @Author: lxy
     * @Description: 容量统计
     * @Date 2021/5/26 19:33
     * @Param vendorId
     * @throws:
     **/
    BocloudResult resourceCapacityNew(Long vendorId, Long vdcId, Long clusterId, String time, String startTime, String endTime, String resourceType,
                                      String condition);

    /**
     * @return com.bocloud.common.model.BocloudResult
     * @Author: lxy
     * @Description: 私有云平台物理、虚拟资源总量
     * @Date 2021/5/27 10:35
     * @Param vendorName
     * @throws:
     **/
    BocloudResult cloudCapacity(Pager pager, String vendorName);
}
