package com.bocloud.cos.intf;

import com.bocloud.common.model.RequestContext;
import com.bocloud.common.model.Result;
import com.bocloud.cos.model.ApplicationParam;
import com.bocloud.cos.model.OrderMessage;
import com.bocloud.cos.params.CloneParams;

/**
 * 服务操作接口
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年4月15日
 */
public interface ResourceApplicationService {

    /**
     * 服务申请
     *
     * @param params
     * @param context
     * @return
     */
    Result process(ApplicationParam params, RequestContext context);

    /**
     * 克隆云主机
     *
     * @param configs
     * @param context
     * @return
     */
    Result clone(CloneParams configs, RequestContext context);

    /**
     * 更新订单状态(k8s调用)
     *
     * @param message
     * @return
     */
    Result updateOrder(OrderMessage message);

}
