package com.bocloud.cos.intf;

import com.bocloud.common.model.*;
import com.bocloud.cos.entity.CloudService;
import com.bocloud.cos.entity.ServiceCatalog;

import java.util.List;

/**
 * 服务目录业务操作接口
 *
 * @author wangyu
 * @version 1.0
 * @since 2019年5月10日
 */
public interface ServiceCatalogService {

    /**
     * 服务目录分页查询
     *
     * @param pager
     * @return
     */
    BocloudResult<GridBean<ServiceCatalog>> list(Pager pager);

    /**
     * 删除服务目录
     *
     * @param id
     * @param userId
     * @return
     */
    Result remove(Long id, Long userId);

    /**
     * 服务目录详情
     *
     * @param id
     * @return
     */
    BocloudResult<ServiceCatalog> detail(Long id);

    /**
     * 新增服务目录
     *
     * @param serviceCatalog
     * @return
     */
    Result create(ServiceCatalog serviceCatalog);

    /**
     * 查询租户下的服务列表
     *
     * @param tenantId
     * @return
     */
    BocloudResult list(Long tenantId);

    /**
     * 查询服务目录下已发布的服务
     *
     * @param code
     * @param tenantId
     * @return
     */
    List<CloudService> listPublishedServicesByCatalog(String code, Long tenantId);
}
