package com.bocloud.cos.intf;

import com.alibaba.fastjson.JSONArray;
import com.bocloud.common.model.*;
import com.bocloud.cos.entity.ServiceCategory;

import java.util.List;

/**
 * 服务类型业务操作接口
 *
 * @author wangyu
 * @version 1.0
 * @since 2019年5月10日
 */
public interface ServiceCategoryService {
    /**
     * 服务类型分页查询
     *
     * @param pager
     * @return
     */
    BocloudResult<GridBean<ServiceCategory>> list(Pager pager);

    /**
     * 删除服务类型
     *
     * @param id
     * @param userId
     * @return
     */
    Result remove(Long id, Long userId);

    /**
     * 服务类型详情
     *
     * @param id
     * @return
     */
    BocloudResult<ServiceCategory> detail(Long id);

    /**
     * 新增服务类型
     *
     * @param serviceCategory
     * @param context
     * @return
     */
    Result create(ServiceCategory serviceCategory, RequestContext context);

    /**
     * 服务类型编辑
     *
     * @param id
     * @param serviceCategory
     * @param context
     * @return
     */
    Result modify(Long id, ServiceCategory serviceCategory, RequestContext context);

    /**
     * 根据code查询服务类型
     *
     * @param code
     * @return
     */
    BocloudResult<List<ServiceCategory>> listByCode(String code);

    /**
     * 查询服务类型列表
     *
     * @param params
     * @return
     */
    BocloudResult<List<ServiceCategory>> list(List<Param> params);

    /**
     * 获取产品类型树
     *
     * @return
     */
    BocloudResult<JSONArray> tree();
}
