package com.bocloud.cos.intf;

import com.bocloud.common.model.*;
import com.bocloud.cos.entity.ServiceSla;
import com.bocloud.cos.params.ServiceSlaParams;

import java.util.List;

/**
 * 服务协议业务接口
 *
 * @author weiwei
 * @version 1.0
 * @since 2020年3月11日
 */
public interface ServiceSlaService {

    /**
     * 查询列表
     *
     * @param pager
     * @param context
     * @return
     */
    BocloudResult<GridBean<ServiceSla>> list(Pager pager, RequestContext context);

    /**
     * 创建
     *
     * @param sla
     * @param context
     * @return
     */
    Result create(ServiceSlaParams sla, RequestContext context);

    /**
     * 修改
     *
     * @param id
     * @param sla
     * @param context
     * @return
     */
    Result modify(Long id, ServiceSlaParams sla, RequestContext context);

    /**
     * 查询详情
     *
     * @param id
     * @return
     */
    BocloudResult<ServiceSla> detail(Long id);

    /**
     * 删除
     *
     * @param id
     * @param context
     * @return
     */
    Result remove(Long id, RequestContext context);

    /**
     * 修改服务SLA状态
     *
     * @param id
     * @param status
     * @param userId
     * @return
     */
    Result updateStatus(Long id, String status, Long userId);

    /**
     * 批量修改服务SLA状态
     *
     * @param ids
     * @param status
     * @param menderId
     * @return
     */
    Result batchUpdateStatus(List<Long> ids, String status, Long menderId);
}
