package com.bocloud.cos.intf;

import com.bocloud.common.model.*;
import com.bocloud.cos.entity.ShoppingCart;
import com.bocloud.cos.model.ApplicationParam;

/**
 * 购物车service接口
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2019/2/18
 */
public interface ShoppingCartService {

    /**
     * 分页查询购物车数据
     *
     * @param pager
     * @param context
     * @return
     */
    BocloudResult<GridBean<ShoppingCart>> list(Pager pager, RequestContext context);

    /**
     * 删除购物车数据
     *
     * @param id
     * @param context
     * @return
     */
    Result remove(Long id, RequestContext context);

    /**
     * 查询购物车清单详情
     *
     * @param id
     * @return
     */
    BocloudResult<ShoppingCart> detail(Long id);

    /**
     * 清空购物车
     *
     * @param context
     * @return
     */
    Result empty(RequestContext context);

    /**
     * 资源申请添加至购物车
     *
     * @param applicationParam
     * @param context
     * @return
     */
    Result create(ApplicationParam applicationParam, RequestContext context);

    /**
     * 购物车批量申请
     *
     * @param context
     * @return
     */
    Result batchApply(RequestContext context);

    /**
     * 更新购物车信息
     *
     * @param id
     * @param applicationParam
     * @param context
     * @return
     */
    Result update(Long id, ApplicationParam applicationParam, RequestContext context);
}
