package com.bocloud.cos.intf;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.RequestContext;
import com.bocloud.common.model.Result;
import com.bocloud.cos.entity.AccountRecord;
import com.bocloud.cos.entity.TenantAccount;

import java.math.BigDecimal;
import java.util.List;

/**
 * 租户授信账户业务接口
 *
 * @author tyl
 * @time 2020/7/15 周三 11:20
 */
public interface TenantAccountService {
    /**
     * 给租户分配(修改)授信账户
     *
     * @param tenantAccount
     * @param requestContext
     * @return
     */
    Result assignAccount(TenantAccount tenantAccount, RequestContext requestContext);

    /**
     * 删除授信账号
     *
     * @param tenantId
     * @param requestContext
     * @return
     */
    Result deleteAccount(Long tenantId, RequestContext requestContext);

    /**
     * 授信账号操作
     *
     * @param tenantId
     * @param billId
     * @param action
     * @param money
     * @param requestContext
     * @return
     */
    Result accountAction(Long tenantId, Long billId, TenantAccount.Action action, BigDecimal money, RequestContext requestContext);

    /**
     * 查看授信账户详情
     *
     * @param tenantId       租户id
     * @param requestContext
     * @return
     */
    BocloudResult<TenantAccount> accountDetail(Long tenantId, RequestContext requestContext);

    /**
     * 查看授信记录
     *
     * @param tenantId
     * @param action
     * @param startTime
     * @param endTime
     * @param requestContext
     * @return
     */
    BocloudResult<List<AccountRecord>> accountRecord(Long tenantId, String action, String startTime, String endTime, RequestContext requestContext);
}
