package com.bocloud.cos.operate;


import com.bocloud.cos.entity.OrderItem;
import com.bocloud.cos.model.AlterationParam;
import com.bocloud.cos.model.ElementModel;
import com.bocloud.cos.model.EmptionModel;

import java.util.Date;
import java.util.List;

/**
 * @author zhangyf
 * @since 2021-12-02
 */
public interface ResourceOperate {

    /**
     * 订单项目类别
     *
     * @return
     */
    OrderItem.Catalog getOrderItemCatalog();

    /**
     * 构建资源申请订单项
     *
     * @param serviceCode
     * @param emptionModel
     * @param elements
     * @return
     */
    List<OrderItem> buildApplyItem(String serviceCode, EmptionModel emptionModel, List<ElementModel> elements);

    /**
     * 构建资源变更订单项
     *
     * @return
     */
    List<OrderItem> buildAlterationItem(String serviceCode, String instance, AlterationParam.Operation operation,
                                        List<ElementModel> elements, Date expiredTime);

}
