package com.bocloud.cos.service;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.cos.entity.PortalElementConfig;
import com.bocloud.cos.intf.PortalElementConfigService;
import com.bocloud.cos.repository.PortalElementConfigRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author lyy
 */
@Service
public class PortalElementConfigServiceImpl implements PortalElementConfigService {
    private static final Logger logger = LoggerFactory.getLogger(PortalElementConfigServiceImpl.class);
    @Autowired
    private PortalElementConfigRepository portalElementConfigRepository;

    @Override
    public BocloudResult list(Long poolId) {
        try {
            List<PortalElementConfig> configs = this.portalElementConfigRepository.list(poolId);
            return new BocloudResult(true, configs, "查询成功");
        } catch (Exception e) {
            logger.error("Query Portal Element Config error:", e);
            return new BocloudResult(false, "查询失败");
        }
    }

}
