package com.bocloud.cos.service;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.cos.entity.PortalElementPool;
import com.bocloud.cos.intf.PortalElementPoolService;
import com.bocloud.cos.repository.PortalElementConfigRepository;
import com.bocloud.cos.repository.PortalElementPoolRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author lyy
 */
@Service
public class PortalElementPoolServiceImpl implements PortalElementPoolService {
    private static final Logger logger = LoggerFactory.getLogger(PortalElementPoolServiceImpl.class);
    @Autowired
    private PortalElementPoolRepository portalElementPoolRepository;
    @Autowired
    private PortalElementConfigRepository portalElementConfigRepository;

    @Override
    public BocloudResult list(String serverName) {
        try {
            List<PortalElementPool> pools = this.portalElementPoolRepository.listPortalElementPool(serverName);
            for (PortalElementPool portalElementPool : pools) {
                portalElementPool.setProperties(portalElementConfigRepository.list(portalElementPool.getId()));
            }
            return new BocloudResult(true, pools, "查询成功");
        } catch (Exception e) {
            logger.error("Query Portal Element Pool error:", e);
            return new BocloudResult(false, "查询失败");
        }
    }

}
