package com.bocloud.cos.utils;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import java.util.concurrent.TimeUnit;

/**
 * 短信验证码缓存
 *
 * @author wangyu
 * @version 1.0
 * @since 2019年5月17日
 */
@Component
public class CaptchaCache {

    @Autowired
    private StringRedisTemplate redisTemplate;

    public void putCache(String key, String value) {
        // 验证码过期时间为120S
        this.redisTemplate.opsForValue().set(key, value, 120, TimeUnit.SECONDS);
    }

    public void putCacheMin(String key, String value) {
        this.redisTemplate.opsForValue().set(key, value, 15, TimeUnit.MINUTES);
    }

    public String getCache(String key) {
        return this.redisTemplate.opsForValue().get(key);
    }

    public Boolean remove(String key) {
        return this.redisTemplate.delete(key);
    }
}